#!/bin/sh
# $Id: t-da-dot-tmo-1.sh,v 1.2 2013/11/26 03:09:13 ca Exp $
#
# Copyright (c) 2011 Claus Assmann
#
# By using this file, you agree to the terms and conditions set
# forth in the license/LICENSE.3C file which can be found at the
# top level of this source code distribution.
#
# ----------------------------------------
# test adaptive timeout in DA for LMTP
# uses smtp1.sh
# ----------------------------------------
#
test -s stop && exit 1
#

if test X"${MTA_NO_SLOW_TEST}" != "X"
then
  echo "SKIPPED: $0: MTA_NO_SLOW_TEST is set"
  exit 0
fi

SD=`dirname $0`
if test "${SD}" = "."
then
   SD=../chkmts
fi
. ${SD}/common.sh

if test X"`uname`" != "XOSF1"
then
while getopts s:V FLAG
do
  case "${FLAG}" in
    s) SKIP="${SKIP} ${OPTARG}";;
    V) VERBOSE=true;;
  esac
done
shift `expr ${OPTIND} - 1`
fi

# cd to working directory for alias file!
cd ../qmgr || exit 1

# create aliases
${CAT} > ${ALI} <<EOF
abuse:	local:
postmaster:	local:
user:	local:
sender: local:
delay: local:
EOF
# create map
rm -f ${ALIMAP}
${MM} < ${ALI}
rm -f ${MTMAP}

# create mailertable (save old version?)
${CAT} > ${MT} <<EOF
local.dom	[127.0.0.1]
other.dom	[127.0.0.1]
local.host	lmtp:
EOF

# ----------------------------------------
# cause a timeout by accepting the mail very slowly
TEST=1
if echo "${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
ERR=false
# use "wait for data to show up in sink, but no longer than N s"?
if ${SHELL} ${SD}/smtp1.sh -3 lmtpsock -Ssender@local.dom -Rdelay@local.host -Q '-T D=2' -C '-O 5' -s 120 -X 0 -A 1 -E 0 -B '-k 8'
then
  if ${GREP} 'func=sc_data, .* reply=$' ${SCL} >/dev/null
  then
    :
  else
    $VERBOSE && echo "$0: test {TEST}: missing 'stat=Connection timed out' in ${SCL}"
    ERR=true
  fi
else
  ERR=true
fi
if ${ERR}
then
   echo "$0: test ${TEST} failed"
   ERRS=`expr ${ERRS} + 1 `
   test X"${MTA_STOPONERROR}" != X && exit 1
fi
fi


# ----------------------------------------
# end
if test ${ERRS} -eq 0
then
  rm -f ${EDBROK}
  exit 0
else
  echo "$0: ${ERRS} error(s)"
  exit 1
fi
