#!/bin/sh
# $Id: t-expr-0.sh,v 1.6 2010/06/10 03:52:44 ca Exp $
#

test -s stop && exit 1

# source directory of this (and other) shell script
SD=`dirname $0`

ERRS=0
OUT=ex0.out
ERR=ex0.err
OK=ex0.ok
PRG=./t-expr-0

TEST=0
for i in 'ten<twelve:1' 'ten>twelve:0' '1+2>one:1' '2-1<two:1' 'ten<ten0:1' '-1<0:1' '!(-1<0):0' '1<2&&2<3:1' '3<2&&2<3:0' '1<2||2<3:1' '3<2||2<3:1' 'nrcpts>1:1'
do
  TEST=`expr $TEST + 1 `
  E=`echo $i | cut -d: -f1`
  R=`echo $i | cut -d: -f2`
  echo "expr == $E;" | $PRG 2>$ERR | grep 'expr:' > $OUT
  printf "expr: %d\n" $R > $OK
  if diff $OUT $OK
  then
    :
  else
    echo "$0: test ${TEST} failed: expr=$E, expected=$R"
    ERRS=`expr ${ERRS} + 1 `
  fi
done

# ----------------
if test "${ERRS}" = "0"
then
  rm -f ${OUT} ${OK} ${ERR}
  exit 0
else
  echo "${ERRS} error(s)"
  exit 1
fi
