/*
 * Copyright (c) 2011 Sendmail, Inc. and its suppliers.
 *      All rights reserved.
 *
 * By using this file, you agree to the terms and conditions set
 * forth in the LICENSE file which can be found at the top level of
 * the sendmail distribution.
 */

#include "sm/generic.h"
SM_RCSID("@(#)$Id: fput4int.c,v 1.1 2011/04/01 17:20:13 ca Exp $")
#include "sm/assert.h"
#include "sm/error.h"
#include "sm/io.h"
#include "io-int.h"
#include "fvwrite.h"

/*
**  SM_IO_FPUT4UINT32 -- add 4 32bit integers to the buffer for the file pointer
**
**	Parameters:
**		fp -- the file pointer for the buffer to be written to
**		n1 -- int to be placed in the buffer
**		n2 -- int to be placed in the buffer
**		n3 -- int to be placed in the buffer
**		n4 -- int to be placed in the buffer
**
**	Returns:
**		usual sm_error code
*/

sm_ret_T
sm_io_fput4uint32(sm_file_T *fp, uint32_t n1, uint32_t n2, uint32_t n3, uint32_t n4)
{
	sm_uio_T uio;
	sm_iov_T iov[4];

	SM_IS_FP(fp);
	iov[0].iov_base = (void *) &n1;
	iov[0].iov_len = sizeof(uint32_t);
	iov[1].iov_base = (void *) &n2;
	iov[1].iov_len = sizeof(uint32_t);
	iov[2].iov_base = (void *) &n3;
	iov[2].iov_len = sizeof(uint32_t);
	iov[3].iov_base = (void *) &n4;
	iov[3].iov_len = sizeof(uint32_t);
	uio.uio_resid = 4 * sizeof(uint32_t);
	uio.uio_iov = &(iov[0]);
	uio.uio_iovcnt = 4;
	return sm_fvwrite(fp, &uio);
}
