#!/bin/sh
# $Id: t-smar-init-0.sh,v 1.7 2013/09/22 04:56:10 ca Exp $
#
# ------------------------------------------------------------
# Description:
# Script to test smar error handling during initialization
# Uses smar
# ------------------------------------------------------------
#

# path to programs
P=..
TPRG=./smar
SD=`dirname $0`
if test "${SD}" = "."
then
   SD=../smar
fi
. ${SD}/common.sh

CONF=alias.conf

if ../smar/smar -D | grep "SMAR_TEST" >/dev/null
then
  :
else
  echo "SKIPPED: $0: need -DSMAR_TEST"
  exit 0
fi

if test X"`uname`" != "XOSF1"
then
while getopts s:V FLAG
do
  case "${FLAG}" in
    s) SKIP="${SKIP} ${OPTARG}";;
    V) VERBOSE=true;;
  esac
done
shift `expr ${OPTIND} - 1`
fi

# create mailertable (save old version?)
${CAT} > ${MT} <<EOF
local.dom	lmtp:
${HOSTNAME}	lmtp:
EOF

# create configuration file
${CAT} > ${CONF} <<EOF
smar {
 Log_Level=10;
}
EOF

E=10200
TEST=1
while [ $E -ge 10000 ]
do
  if ${TPRG} -t $E -f ${CONF}
  then
    [ -s *core ] && break
  else
    ERRS=`expr ${ERRS} + 1 `
    echo "$0: test ${TEST} failed."
    test X"${MTA_STOPONERROR}" != X && break
  fi
  E=`expr $E - 10 `
  TEST=`expr $TEST + 1 `
done

rm -f ${CONF}

exit ${ERRS}
