#!/bin/sh
# $Id: t-msgmod-9.sh,v 1.1 2008/01/28 01:30:35 ca Exp $
#
# ----------------------------------------
# test message body modifications: multiple pre/append
# uses t-msgmod-0
# ----------------------------------------
#
test -s stop && exit 1
#

GREP=grep
ERR=false
ERRS=0
if test X"`uname`" != "XOSF1"
then
while getopts s:V FLAG
do
  case "${FLAG}" in
    s) SKIP="${SKIP} ${OPTARG}";;
    V) VERBOSE=true;;
  esac
done
shift `expr ${OPTIND} - 1`
fi

TPRG=./t-msgmod-0
IN=msg-9.in
OK=msg-9.ok
OUT=msg-9.out

# ----------------------------------------
# test: prepend headers
TEST=1
if echo " ${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
ERR=false

cat > ${IN} <<EOF
Received: from someone
From: a
To: b
Subject: c

body
.
EOF

cat > ${OK} <<EOF
X-HdrP0: prepend 0
X-HdrP1: prepend 1
Received: from someone
From: a
To: b
Subject: c

body
.
EOF

${TPRG} -M p='X-HdrP0: prepend 0' -M p='X-HdrP1: prepend 1' < ${IN} > ${OUT}
if diff ${OK} ${OUT}
then
   :
else
   echo "$0: test ${TEST} failed"
   ERR=true
fi

if ${ERR}
then
   echo "$0: test ${TEST} failed"
   ERRS=`expr ${ERRS} + 1 `
   test X"${MTA_STOPONERROR}" != X && exit 1
fi

else
  ${VERBOSE} && echo "$0: test ${TEST} SKIPPED"
fi


# ----------------------------------------
# test: append headers
TEST=2
if echo " ${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
ERR=false

cat > ${IN} <<EOF
Received: from someone
From: a
To: b
Subject: c

body
.
EOF

cat > ${OK} <<EOF
Received: from someone
From: a
To: b
Subject: c
X-HdrA0: append 0
X-HdrA1: append 1

body
.
EOF

${TPRG} -M a='X-HdrA0: append 0' -M a='X-HdrA1: append 1' < ${IN} > ${OUT}
if diff ${OK} ${OUT}
then
   :
else
   echo "$0: test ${TEST} failed"
   ERR=true
fi

if ${ERR}
then
   echo "$0: test ${TEST} failed"
   ERRS=`expr ${ERRS} + 1 `
   test X"${MTA_STOPONERROR}" != X && exit 1
fi

else
  ${VERBOSE} && echo "$0: test ${TEST} SKIPPED"
fi




# ----------------------------------------
# end
if test "${ERRS}" = "0"
then
  rm -f ${IN} ${OK} ${OUT}
  exit 0
else
  echo "${ERRS} error(s)"
  exit 1
fi
